---
title: Device Authentication (One-time SMS)
description: For organizations that prefer to maintain their own user device information, you can call the {{apiPath}}/v1/{{envID}}/deviceAuthentications endpoint and include the selectedDevice.oneTime object to provide the information required to contact the user for authentication. This example shows the use of the oneTime object for contacting the user by SMS.
component: pingone-api
page_id: pingone-api:mfa:mfa-authentication/mfa-device-authentications/onetime-authentication-sms
canonical_url: https://developer.pingidentity.com/pingone-api/mfa/mfa-authentication/mfa-device-authentications/onetime-authentication-sms.html
section_ids:
  headers: Headers
  body: Body
  example-request: Example Request
  example-response: Example Response
---

# Device Authentication (One-time SMS)

##

```none
POST {{authPath}}/{{envID}}/deviceAuthentications
```

For organizations that prefer to maintain their own user device information, you can call the `{{apiPath}}/v1/{{envID}}/deviceAuthentications` endpoint and include the `selectedDevice.oneTime` object to provide the information required to contact the user for authentication. This example shows the use of the `oneTime` object for contacting the user by SMS.

> **Collapse: Request Model**
>
> | Property                       | Type   | Required? |
> | ------------------------------ | ------ | --------- |
> | `user.id`                      | String | Required  |
> | `selectedDevice.oneTime.type`  | String | Optional  |
> | `selectedDevice.oneTime.phone` | String | Optional  |
>
> Refer to the [Device authentications](#device-authentications-data-model) data model for full property descriptions.

### Headers

Authorization      Bearer {{accessToken}}

Content-Type      application/json

### Body

raw ( application/json )

```json
{
    "user": {
        "id": "{{userID}}"
    },
    "selectedDevice": {
        "oneTime": {
            "type": "SMS",
            "phone": "+14135550150"
        }
    }
}
```

##

### Example Request

* cURL

* C#

* Go

* HTTP

* Java

* jQuery

* NodeJS

* Python

* PHP

* Ruby

* Swift

```shell
curl --location --globoff '{{authPath}}/{{envID}}/deviceAuthentications' \
--header 'Content-Type: application/json' \
--header 'Authorization: Bearer {{accessToken}}' \
--data '{
    "user": {
        "id": "{{userID}}"
    },
    "selectedDevice": {
        "oneTime": {
            "type": "SMS",
            "phone": "+14135550150"
        }
    }
}'
```

```csharp
var options = new RestClientOptions("{{authPath}}/{{envID}}/deviceAuthentications")
{
  MaxTimeout = -1,
};
var client = new RestClient(options);
var request = new RestRequest("", Method.Post);
request.AddHeader("Content-Type", "application/json");
request.AddHeader("Authorization", "Bearer {{accessToken}}");
var body = @"{" + "\n" +
@"    ""user"": {" + "\n" +
@"        ""id"": ""{{userID}}""" + "\n" +
@"    }," + "\n" +
@"    ""selectedDevice"": {" + "\n" +
@"        ""oneTime"": {" + "\n" +
@"            ""type"": ""SMS""," + "\n" +
@"            ""phone"": ""+14135550150""" + "\n" +
@"        }" + "\n" +
@"    }" + "\n" +
@"}";
request.AddStringBody(body, DataFormat.Json);
RestResponse response = await client.ExecuteAsync(request);
Console.WriteLine(response.Content);
```

```golang
package main

import (
  "fmt"
  "strings"
  "net/http"
  "io"
)

func main() {

  url := "{{authPath}}/{{envID}}/deviceAuthentications"
  method := "POST"

  payload := strings.NewReader(`{
    "user": {
        "id": "{{userID}}"
    },
    "selectedDevice": {
        "oneTime": {
            "type": "SMS",
            "phone": "+14135550150"
        }
    }
}`)

  client := &http.Client {
  }
  req, err := http.NewRequest(method, url, payload)

  if err != nil {
    fmt.Println(err)
    return
  }
  req.Header.Add("Content-Type", "application/json")
  req.Header.Add("Authorization", "Bearer {{accessToken}}")

  res, err := client.Do(req)
  if err != nil {
    fmt.Println(err)
    return
  }
  defer res.Body.Close()

  body, err := io.ReadAll(res.Body)
  if err != nil {
    fmt.Println(err)
    return
  }
  fmt.Println(string(body))
}
```

```http
POST /{{envID}}/deviceAuthentications HTTP/1.1
Host: {{authPath}}
Content-Type: application/json
Authorization: Bearer {{accessToken}}

{
    "user": {
        "id": "{{userID}}"
    },
    "selectedDevice": {
        "oneTime": {
            "type": "SMS",
            "phone": "+14135550150"
        }
    }
}
```

```java
OkHttpClient client = new OkHttpClient().newBuilder()
  .build();
MediaType mediaType = MediaType.parse("application/json");
RequestBody body = RequestBody.create(mediaType, "{\n    \"user\": {\n        \"id\": \"{{userID}}\"\n    },\n    \"selectedDevice\": {\n        \"oneTime\": {\n            \"type\": \"SMS\",\n            \"phone\": \"+14135550150\"\n        }\n    }\n}");
Request request = new Request.Builder()
  .url("{{authPath}}/{{envID}}/deviceAuthentications")
  .method("POST", body)
  .addHeader("Content-Type", "application/json")
  .addHeader("Authorization", "Bearer {{accessToken}}")
  .build();
Response response = client.newCall(request).execute();
```

```javascript
var settings = {
  "url": "{{authPath}}/{{envID}}/deviceAuthentications",
  "method": "POST",
  "timeout": 0,
  "headers": {
    "Content-Type": "application/json",
    "Authorization": "Bearer {{accessToken}}"
  },
  "data": JSON.stringify({
    "user": {
      "id": "{{userID}}"
    },
    "selectedDevice": {
      "oneTime": {
        "type": "SMS",
        "phone": "+14135550150"
      }
    }
  }),
};

$.ajax(settings).done(function (response) {
  console.log(response);
});
```

```javascript
var request = require('request');
var options = {
  'method': 'POST',
  'url': '{{authPath}}/{{envID}}/deviceAuthentications',
  'headers': {
    'Content-Type': 'application/json',
    'Authorization': 'Bearer {{accessToken}}'
  },
  body: JSON.stringify({
    "user": {
      "id": "{{userID}}"
    },
    "selectedDevice": {
      "oneTime": {
        "type": "SMS",
        "phone": "+14135550150"
      }
    }
  })

};
request(options, function (error, response) {
  if (error) throw new Error(error);
  console.log(response.body);
});
```

```python
import requests
import json

url = "{{authPath}}/{{envID}}/deviceAuthentications"

payload = json.dumps({
  "user": {
    "id": "{{userID}}"
  },
  "selectedDevice": {
    "oneTime": {
      "type": "SMS",
      "phone": "+14135550150"
    }
  }
})
headers = {
  'Content-Type': 'application/json',
  'Authorization': 'Bearer {{accessToken}}'
}

response = requests.request("POST", url, headers=headers, data=payload)

print(response.text)
```

```php
<?php
require_once 'HTTP/Request2.php';
$request = new HTTP_Request2();
$request->setUrl('{{authPath}}/{{envID}}/deviceAuthentications');
$request->setMethod(HTTP_Request2::METHOD_POST);
$request->setConfig(array(
  'follow_redirects' => TRUE
));
$request->setHeader(array(
  'Content-Type' => 'application/json',
  'Authorization' => 'Bearer {{accessToken}}'
));
$request->setBody('{\n    "user": {\n        "id": "{{userID}}"\n    },\n    "selectedDevice": {\n        "oneTime": {\n            "type": "SMS",\n            "phone": "+14135550150"\n        }\n    }\n}');
try {
  $response = $request->send();
  if ($response->getStatus() == 200) {
    echo $response->getBody();
  }
  else {
    echo 'Unexpected HTTP status: ' . $response->getStatus() . ' ' .
    $response->getReasonPhrase();
  }
}
catch(HTTP_Request2_Exception $e) {
  echo 'Error: ' . $e->getMessage();
}
```

```ruby
require "uri"
require "json"
require "net/http"

url = URI("{{authPath}}/{{envID}}/deviceAuthentications")

http = Net::HTTP.new(url.host, url.port);
request = Net::HTTP::Post.new(url)
request["Content-Type"] = "application/json"
request["Authorization"] = "Bearer {{accessToken}}"
request.body = JSON.dump({
  "user": {
    "id": "{{userID}}"
  },
  "selectedDevice": {
    "oneTime": {
      "type": "SMS",
      "phone": "+14135550150"
    }
  }
})

response = http.request(request)
puts response.read_body
```

```swift
let parameters = "{\n    \"user\": {\n        \"id\": \"{{userID}}\"\n    },\n    \"selectedDevice\": {\n        \"oneTime\": {\n            \"type\": \"SMS\",\n            \"phone\": \"+14135550150\"\n        }\n    }\n}"
let postData = parameters.data(using: .utf8)

var request = URLRequest(url: URL(string: "{{authPath}}/{{envID}}/deviceAuthentications")!,timeoutInterval: Double.infinity)
request.addValue("application/json", forHTTPHeaderField: "Content-Type")
request.addValue("Bearer {{accessToken}}", forHTTPHeaderField: "Authorization")

request.httpMethod = "POST"
request.httpBody = postData

let task = URLSession.shared.dataTask(with: request) { data, response, error in
  guard let data = data else {
    print(String(describing: error))
    return
  }
  print(String(data: data, encoding: .utf8)!)
}

task.resume()
```

### Example Response

201 Created

```json
{
    "_links": {
        "self": {
            "href": "https://auth.pingone.eu/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/deviceAuthentications/0ff545da-016a-4ae7-a8c6-84d67f7b20ea"
        },
        "device.select": {
            "href": "https://auth.pingone.eu/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/deviceAuthentications/0ff545da-016a-4ae7-a8c6-84d67f7b20ea"
        },
        "otp.check": {
            "href": "https://auth.pingone.eu/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/deviceAuthentications/0ff545da-016a-4ae7-a8c6-84d67f7b20ea"
        }
    },
    "_embedded": {
        "devices": [
            {
                "type": "SMS",
                "phone": "*******44"
            }
        ]
    },
    "id": "0ff545da-016a-4ae7-a8c6-84d67f7b20ea",
    "environment": {
        "id": "abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6"
    },
    "status": "OTP_REQUIRED",
    "policy": {
        "id": "5a0a0950-8a81-4739-b12a-f4d6a11c7a82"
    },
    "selectedDevice": {
        "oneTime": {
            "type": "SMS",
            "phone": "*******44"
        }
    },
    "user": {
        "id": "991776fd-145b-499e-8237-2c62aef35b2c"
    },
    "createdAt": "2022-06-16T14:12:25.618Z",
    "updatedAt": "2022-06-16T14:12:25.785Z"
}
```
